diff -r -u squid-2.6.STABLE13/src/url.c new-STABLE13/src/url.c
--- squid-2.6.STABLE13/src/url.c	Sun Mar  4 03:34:13 2007
+++ new-STABLE13/src/url.c	Sun May 13 00:59:37 2007
@@ -110,6 +110,8 @@
 };
 
 static request_t *urnParse(method_t method, char *urn);
+static const char valid_ipv6_addr_chars[] =
+"ABCDEFabcdef0123456789:";
 static const char valid_hostname_chars_u[] =
 "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
 "abcdefghijklmnopqrstuvwxyz"
@@ -287,7 +289,10 @@
 	    *t = 0;
 	    strcpy((char *) host, t + 1);
 	}
-	if ((t = strrchr(host, ':'))) {
+	q = host;
+	if (strchr(host, '[') && strchr(host, ']'))
+	    q =  strchr(host, ']');
+	if ((t = strrchr(q, ':'))) {
 	    *t++ = '\0';
 	    if (*t != '\0')
 		port = atoi(t);
@@ -306,12 +311,20 @@
 	    *q = '\0';
 	}
     }
-    if (Config.onoff.check_hostnames && strspn(host, Config.onoff.allow_underscore ? valid_hostname_chars_u : valid_hostname_chars) != strlen(host)) {
-	debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
-	return NULL;
+    if (host == strrchr(host, '[') && 
+	(host + strlen(host)-1) == strchr(host, ']')) {
+	if (strspn(host+1, valid_ipv6_addr_chars) != strlen(host)-2) { /* IPv6 address */
+	    debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
+	    return NULL;
+	}
+    } else {
+	if (Config.onoff.check_hostnames && strspn(host, Config.onoff.allow_underscore ? valid_hostname_chars_u : valid_hostname_chars) != strlen(host)) {
+	    debug(23, 1) ("urlParse: Illegal character in hostname '%s'\n", host);
+	    return NULL;
+	}
+	if (Config.appendDomain && !strchr(host, '.'))
+	    strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN - strlen(host) - 1);
     }
-    if (Config.appendDomain && !strchr(host, '.'))
-	strncat(host, Config.appendDomain, SQUIDHOSTNAMELEN - strlen(host) - 1);
     /* remove trailing dots from hostnames */
     while ((l = strlen(host)) > 0 && host[--l] == '.')
 	host[l] = '\0';
@@ -358,7 +371,12 @@
 	}
     }
     request = requestCreate(method, protocol, urlpath);
-    xstrncpy(request->host, host, SQUIDHOSTNAMELEN);
+    if (strchr(host, '[')) {
+	xstrncpy(request->host, host+1, SQUIDHOSTNAMELEN);
+	request->host[strlen(host)-2] = '\0';
+    }
+    else
+	xstrncpy(request->host, host, SQUIDHOSTNAMELEN);
     xstrncpy(request->login, login, MAX_LOGIN_SZ);
     request->port = (u_short) port;
     return request;
@@ -405,6 +423,7 @@
 char *
 urlCanonicalClean(const request_t * request)
 {
+    LOCAL_ARRAY(char, hostbuf, MAX_URL);
     LOCAL_ARRAY(char, buf, MAX_URL);
     LOCAL_ARRAY(char, portbuf, 32);
     LOCAL_ARRAY(char, loginbuf, MAX_LOGIN_SZ + 1);
@@ -414,7 +433,11 @@
     } else {
 	switch (request->method) {
 	case METHOD_CONNECT:
-	    snprintf(buf, MAX_URL, "%s:%d", request->host, request->port);
+	    if (strchr(request->host, ':')) 
+		snprintf(hostbuf, MAX_URL, "[%s]", request->host);
+	    else
+		snprintf(hostbuf, MAX_URL, "%s", request->host);
+	    snprintf(buf, MAX_URL, "%s:%d", hostbuf, request->port);
 	    break;
 	default:
 	    portbuf[0] = '\0';
@@ -427,10 +450,14 @@
 		    *t = '\0';
 		strcat(loginbuf, "@");
 	    }
+	    if (strchr(request->host, ':')) 
+		snprintf(hostbuf, MAX_URL, "[%s]", request->host);
+	    else
+		snprintf(hostbuf, MAX_URL, "%s", request->host);
 	    snprintf(buf, MAX_URL, "%s://%s%s%s%s",
 		ProtocolStr[request->protocol],
 		loginbuf,
-		request->host,
+		hostbuf,
 		portbuf,
 		strBuf(request->urlpath));
 	    /*
diff -r -u squid-2.6.STABLE13/src/wccp.c new-STABLE13/src/wccp.c
--- squid-2.6.STABLE13/src/wccp.c	Tue Jun 27 00:01:59 2006
+++ new-STABLE13/src/wccp.c	Sun May 13 00:59:37 2007
@@ -112,7 +112,7 @@
     last_id = 0;
     last_assign_buckets_change = 0;
     number_caches = 0;
-    if (Config.Wccp.router.s_addr != any_addr.s_addr)
+    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr != any_addr.s_addr)
 	if (!eventFind(wccpHereIam, NULL))
 	    eventAdd("wccpHereIam", wccpHereIam, NULL, 5.0, 1);
 }
@@ -124,14 +124,17 @@
     struct sockaddr_in router, local;
     socklen_t local_len, router_len;
     debug(80, 5) ("wccpConnectionOpen: Called\n");
-    if (Config.Wccp.router.s_addr == any_addr.s_addr) {
+    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr == any_addr.s_addr) {
 	debug(1, 1) ("WCCP Disabled.\n");
 	return;
     }
+    if (Config.Wccp.address.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&Config.Wccp.address)->sin6_port = ntohs(port);
+    else
+	((struct sockaddr_in *)&Config.Wccp.address)->sin_port = ntohs(port);
     theWccpConnection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	Config.Wccp.address,
-	port,
+	&Config.Wccp.address,
 	COMM_NONBLOCKING,
 	"WCCP Socket");
     if (theWccpConnection < 0)
@@ -147,7 +150,7 @@
     memset(&router, '\0', router_len);
     router.sin_family = AF_INET;
     router.sin_port = htons(port);
-    router.sin_addr = Config.Wccp.router;
+    router.sin_addr = ((struct sockaddr_in *)&Config.Wccp.router)->sin_addr;
     if (connect(theWccpConnection, (struct sockaddr *) &router, router_len))
 	fatal("Unable to connect WCCP out socket");
     local_len = sizeof(local);
@@ -206,7 +209,7 @@
 	(unsigned) ntohl(wccp_i_see_you.number));
     if (len < 0)
 	return;
-    if (Config.Wccp.router.s_addr != from.sin_addr.s_addr)
+    if (((struct sockaddr_in *)&Config.Wccp.router)->sin_addr.s_addr != from.sin_addr.s_addr)
 	return;
     if (ntohl(wccp_i_see_you.version) != Config.Wccp.version)
 	return;
diff -r -u squid-2.6.STABLE13/src/wccp2.c new-STABLE13/src/wccp2.c
--- squid-2.6.STABLE13/src/wccp2.c	Tue Apr 17 18:40:59 2007
+++ new-STABLE13/src/wccp2.c	Sun May 13 00:59:37 2007
@@ -523,7 +523,7 @@
 void
 wccp2Init(void)
 {
-    sockaddr_in_list *s;
+    sockaddr_storage_list *s;
     char *ptr;
     uint32_t service_flags;
     struct wccp2_service_list_t *service_list_ptr;
@@ -537,7 +537,7 @@
 
     /* Calculate the number of routers configured in the config file */
     for (s = Config.Wccp2.router; s; s = s->next) {
-	if (s->s.sin_addr.s_addr != any_addr.s_addr) {
+	if (((struct sockaddr_in *)&s->s)->sin_addr.s_addr != any_addr.s_addr) {
 	    /* Increment the counter */
 	    wccp2_numrouters++;
 	}
@@ -670,15 +670,15 @@
 
 	/* Add each router.  Keep this functionality here to make sure the received_id can be updated in the packet */
 	for (s = Config.Wccp2.router; s; s = s->next) {
-	    if (s->s.sin_addr.s_addr != any_addr.s_addr) {
+	    if (((struct sockaddr_in *)&s->s)->sin_addr.s_addr != any_addr.s_addr) {
 		wccp2_here_i_am_header.length += sizeof(struct wccp2_router_id_element_t);
 		assert(wccp2_here_i_am_header.length <= WCCP_RESPONSE_SIZE);
 
 		/* Add a pointer to the router list for this router */
 		router_list_ptr->info = (struct wccp2_router_id_element_t *) ptr;
-		router_list_ptr->info->router_address = s->s.sin_addr;
+		router_list_ptr->info->router_address = ((struct sockaddr_in *)&s->s)->sin_addr;
 		router_list_ptr->info->received_id = htonl(0);
-		router_list_ptr->router_sendto_address = s->s.sin_addr;
+		router_list_ptr->router_sendto_address = ((struct sockaddr_in *)&s->s)->sin_addr;
 		router_list_ptr->member_change = htonl(0);
 
 		/* Build the next struct */
@@ -764,10 +764,13 @@
 	debug(80, 2) ("WCCPv2 Disabled.\n");
 	return;
     }
+    if (Config.Wccp2.address.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&Config.Wccp2.address)->sin6_port = ntohs(port);
+    else
+	((struct sockaddr_in *)&Config.Wccp2.address)->sin_port = ntohs(port);
     theWccp2Connection = comm_open(SOCK_DGRAM,
 	IPPROTO_UDP,
-	Config.Wccp2.address,
-	port,
+	&Config.Wccp2.address,
 	COMM_NONBLOCKING,
 	"WCCPv2 Socket");
     if (theWccp2Connection < 0)
